;###############################################################################################
;					   TYMON
;###############################################################################################

; compilation:
; ml  /c  /coff  /Cp name.asm
; link /SUBSYSTEM:WINDOWS  /LIBPATH:c:\masm32\lib  name.obj name.res

;###############################################################################################
;					   MODEL
;###############################################################################################

.486
.model flat,stdcall
option casemap:none

;###############################################################################################
;					  INCLUDE
;###############################################################################################

include c:\masm32\include\windows.inc
include c:\masm32\include\user32.inc
include c:\masm32\include\kernel32.inc
include c:\masm32\include\comdlg32.inc
include	c:\masm32\include\gdi32.inc
include c:\masm32\include\advapi32.inc
include c:\masm32\include\shell32.inc

includelib c:\masm32\lib\shell32.lib
includelib c:\masm32\lib\advapi32.lib 
includelib c:\masm32\lib\user32.lib
includelib c:\masm32\lib\gdi32.lib
includelib c:\masm32\lib\kernel32.lib
includelib c:\masm32\lib\comdlg32.lib

;###############################################################################################
;					    PROTO
;###############################################################################################

; prototypes of function

MD4		PROTO	:DWORD, :DWORD, :DWORD
czeq_hash 	PROTO	:DWORD
MD5_INV		PROTO	:DWORD, :DWORD, :DWORD

;###############################################################################################
;					    MACROS
;###############################################################################################

RGB MACRO red, green, blue
    xor eax, eax
    mov al, blue    ; blue
    rol eax, 8
    mov al, green   ; green
    rol eax, 8
    mov al, red     ; red
ENDM

;###############################################################################################
;					    CONST
;###############################################################################################

.const

 DIALOG1	equ	1000

 ID_ICON	equ	1001

 ID_ABOUT	equ	301
 ID_EXIT	equ	302

 ID_EDIT	equ	201
 ID_EDIT2	equ	202

 ID_CRACKER	equ	900

;###############################################################################################
;					     DATA
;###############################################################################################

.data

 bad_name	db	'Something wrong...',0
 lpSize 	dd 	sizeof _name
 sCaption	db	'keygen for CrackMe #5 by ReWolf',0
 sCracker	db	'Tymon // tkm!',0
 format		db	'%08X%08X%08X%08X%08X%08X%08X%08X',0
 _caption	db	'about',0

 _text		db	'keygen for CrackMe #5 by ReWolf',13,10
		db	'tHE Unofficial HTBTeam Trial Crackme',13,10
		db	'made by Tymon//tkm!',13,10
		db	'protection: MD5 (modified), MD4',13,10
		db	'date: 23.07.2005',0

 _data1         dd 	30FB40D4h, 9FA0FF0Bh, 6BECCD2Fh, 3F258C7Ah		; cast-128 sbox
                dd 	1E213F2Fh, 9C004DD3h, 6003E540h, 0CF9FC949h
                dd 	0BFD4AF27h, 88BBBDB5h, 0E2034090h, 98D09675h
                dd 	6E63A0E0h, 15C361D2h, 0C2E7661Dh, 22D4FF8Eh

 _data2         dd 	8DEFC240h, 25FA5D9Fh, 0EB903DBFh, 0E810C907h
                dd 	47607FFFh, 369FE44Bh, 8C1FC644h, 0AECECA90h
                dd 	0BEB1F9BFh, 0EEFBCAEAh, 0E8CF1950h, 51DF07AEh
                dd 	920E8806h, 0F0AD0548h, 0E13C8D83h, 927010D5h


;###############################################################################################
;					     DATA?
;###############################################################################################

.data?

 _name		db	65 dup(?)
 _serial	db	74 dup(?)
 _szSerial	db	150 dup (?)

 _md5		db	16 dup(?)

 hInstance 	dd	?
 hIcon	  	dd	?

 lpLF		LOGFONT		<?>

;###############################################################################################
;					    CODE
;###############################################################################################

.code

	; --==include==--

 Start:

	invoke	GetModuleHandle, NULL
	mov	hInstance, eax
	xor	ecx, ecx
	push	ecx
	push	offset DlgProc
	push	ecx
	push	DIALOG1
	push	eax
	Call	DialogBoxParamA
	invoke	ExitProcess, NULL

;###############################################################################################
;					   DLGPROC
;###############################################################################################

DlgProc proc uses esi edi ebx hWnd:DWORD, wmsg:DWORD, wparam:DWORD, lparam:DWORD 

	mov	eax, dword ptr[wmsg]

	cmp 	eax, WM_CLOSE
	je  	close
	cmp 	eax, WM_COMMAND
	je  	command
	cmp 	eax, WM_INITDIALOG
	je  	initdialog
	cmp	eax, WM_MOUSEMOVE
	je	moveform

end_dlgproc:

	xor	eax, eax
	ret

;###############################################################################################
;					WM_COMMAND
;###############################################################################################

 command:

	mov	eax, dword ptr[wparam]
	
	cmp	eax, ID_ABOUT
	je	about
	cmp	eax, ID_EXIT
	je 	close
	cmp	ax, ID_EDIT
	je	make
	cmp	ax, 02
	je	close

	jmp	end_dlgproc

;###############################################################################################
;					    CLOSE
;###############################################################################################

 close:
	invoke 	EndDialog, hWnd, NULL
	jmp	end_dlgproc

;###############################################################################################
;					  INITDIALOG
;###############################################################################################

 initdialog:

	invoke	LoadIcon, hInstance, ID_ICON				; load icon
	invoke	SendMessage, hWnd, WM_SETICON, NULL, eax

	invoke	SendMessage, hWnd, WM_SETTEXT, NULL, offset sCaption
	invoke	SetDlgItemText, hWnd, ID_CRACKER, offset sCracker	; made by ...

	invoke	GetUserName, offset _name, offset lpSize		; get user name
	invoke	SetDlgItemText, hWnd, ID_EDIT, offset _name		; and save

	invoke	SendMessage,hWnd,WM_GETFONT,0,0				; bold font
	mov	esi,offset lpLF
	assume	esi:ptr	LOGFONT
	invoke	GetObject,eax,sizeof LOGFONT,esi
	mov	[esi].lfWeight,	FW_BOLD

	invoke	CreateFontIndirect,esi
	mov	ebx, eax
	invoke	SendDlgItemMessage,hWnd,ID_CRACKER,WM_SETFONT,ebx,0
	invoke	SendDlgItemMessage,hWnd,ID_EDIT,WM_SETFONT,ebx,0
	invoke	SendDlgItemMessage,hWnd,ID_EDIT2,WM_SETFONT,ebx,0

	invoke	SetDlgItemText, hWnd, ID_CRACKER, offset sCracker

	invoke	GetDlgItem, hWnd, ID_EXIT
	invoke	SetFocus, eax

	jmp	end_dlgproc

;###############################################################################################
;					   MOVEFORM
;###############################################################################################
 moveform:
	cmp	wparam, 1						; moveform ;-)
	jne	@f

	call	ReleaseCapture
	invoke	SendMessage, hWnd, WM_SYSCOMMAND, 0F012h, 0
@@:
	jmp	end_dlgproc

;###############################################################################################
;					  ABOUT BOX
;###############################################################################################

 about:
	invoke	MessageBox,hWnd, offset _text, offset _caption, MB_OK or MB_ICONINFORMATION
	jmp	end_dlgproc

;###############################################################################################
;					 GENERATE S/N
;###############################################################################################

 make:	

	;	int	3

		mov	edi, offset _name			; lot of garbage... sorry..
		mov	esi, offset _md5

		invoke	GetDlgItemTextA, hWnd, ID_EDIT, edi, 65
		test	eax, eax
		jz	_ohnoBad

		invoke	MD4, edi, eax, esi			; md4 (name)
		invoke	czeq_hash, esi				; check hash

		mov	edi, offset _serial
		mov	ecx, 4
		push	edi					; save offset _serial on stack

@@:
		push	ecx					;  solving the equation

		movsx	eax, byte ptr [esi]
		movsx	ebx, byte ptr [esi+1]
		movsx	ecx, byte ptr [esi+2]
		movsx	edx, byte ptr [esi+3]

		mov	byte ptr [edi+4], al
		mov	byte ptr [edi+5], bl

		imul	eax, edx
		imul	ebx, ecx

		mov	word ptr [edi], ax
		mov	word ptr [edi+2], bx

		pop	ecx
		add	esi, 4
		add	edi, 6
		dec	ecx
		jnz	@b

		pop	esi					; mov	esi, offset _serial

		invoke	MD4, esi, 24, edi			; md4(first 24 bytes of non-hashed serial)

		push	esi

		mov	esi, edi
		push	8
		pop	ecx					; have to mix a bit this md4 hash
@@:
		lodsb
		stosb
		inc	esi
		loop	@b

		pop	esi

		invoke	MD5_INV, offset _data1, 37h, esi	; md5_inv (first part of sn)
		add	esi, 16
		invoke	MD5_INV, offset _data2, 37h, esi	; md5_inv (second part of sn)

		mov	ecx, 8
		add	esi, 16-4

		std						; hex2hexstr

@@:
		lodsd
		bswap	eax
		push	eax
		loop	@b

		cld

		push	offset format
		push	offset _szSerial
		call	wsprintfA

		add	esp, 4*10

		invoke	SetDlgItemText,hWnd,ID_EDIT2,offset _szSerial


		jmp	end_dlgproc					 ; end

;###############################################################################################
;					NOTHING or BAD
;###############################################################################################

 _ohnoBad:
	invoke	SetDlgItemText, hWnd, ID_EDIT2, offset bad_name;  ; badname
	jmp	end_dlgproc
	
DlgProc endp

include	md4.inc
include md5_invert.inc
include name_mix.inc

end Start
