comment *

algorithm: 	MD5 (modified!)
size of digest:	128 bits (16 bytes)

 example:

 	push 	offset _buffer	; the pointer of buffer to receive message digest (16 bytes)
	push	nSize		; the number of bytes of the data to be hashed
	push	offset _data	; the pointer of the data to be hashed
	call	MD5_INV

	or:
	invoke	MD5_INV, offset _data, nSize, offset _buffer

Tymon//tkm! <tymon_crk@wp.pl> www.tymon.crack.pl

important: use it at your own risk
*

MD5_INV	PROTO	:DWORD, :DWORD, :DWORD

HH	macro	_a,_b,_c,_d,k,s,i	; inv !!!

	sub	_a, _b
	mov	eax, _b
	ror	_a, s
	xor	eax, _c
	sub	_a, k
	xor	eax, _d
	sub 	_a, i
	sub	_a, eax

endm


.data?

paddbuf_inv		db	2*64 dup(?)
fpadd_inv		dd	?
rounds_inv		dd	?

.code

OPTION PROLOGUE: NONE
OPTION EPILOGUE: NONE

_64_inv	dd	64
_8_inv	dd	8

MD5_INV proc data:DWORD, l:DWORD, buffer:DWORD

	pushad

	mov	esi, [esp+24h]	; data
	mov	eax, [esp+28h]	; length
	xor	edx, edx
	add	esi, eax
	div	[_64_inv]
	mov	rounds_inv, eax

	sub	esi, edx
	mov	edi, offset paddbuf_inv
	mov	ecx, edx
	rep movsb

	inc	ecx

	sub	edx, 56
	js	_2

	sub	edx, 64
	inc	ecx
_2:
	mov	fpadd_inv, ecx

	inc	edx
	xor	eax, eax
	mov	byte ptr[edi], 80h
	xchg	edx, ecx
	inc	edi
	neg	ecx
	rep stosb

	xor	edx, edx
	mov	eax, [esp+28h]			; length
	mul	[_8_inv]	
	
	mov	dword ptr[edi],   eax		; add length in bits
	mov	dword ptr[edi+4], edx

	mov	esi, [esp+2Ch]			; buffer

;	mov	dword ptr[esi+0*4], 067452301h
;	mov	dword ptr[esi+1*4], 0EFCDAB89h
;	mov	dword ptr[esi+2*4], 098BADCFEh
;	mov	dword ptr[esi+3*4], 010325476h

	mov	eax, rounds_inv

	test	eax, eax
	jz	_padd

	mov	edi, [esp+24h]	; data

_next:
;	push	esi				; save pointer

	mov	ebp, dword ptr[esi+0*4]
	mov	ebx, dword ptr[esi+1*4]
	mov	ecx, dword ptr[esi+2*4]
	mov	edx, dword ptr[esi+3*4]

;       /* Round 4. */

	HH	ebx,ecx,edx,ebp,dword ptr[edi+ 9*4],21,0EB86D391h
	HH	ecx,edx,ebp,ebx,dword ptr[edi+ 2*4],15,02AD7D2BBh
	HH	edx,ebp,ebx,ecx,dword ptr[edi+11*4],10,0BD3AF235h
	HH	ebp,ebx,ecx,edx,dword ptr[edi+ 4*4], 6,0F7537E82h
	HH	ebx,ecx,edx,ebp,dword ptr[edi+13*4],21,04E0811A1h
	HH	ecx,edx,ebp,ebx,dword ptr[edi+ 6*4],15,0A3014314h
	HH	edx,ebp,ebx,ecx,dword ptr[edi+15*4],10,0FE2CE6E0h
	HH	ebp,ebx,ecx,edx,dword ptr[edi+ 8*4], 6,06FA87E4Fh
	HH	ebx,ecx,edx,ebp,dword ptr[edi+ 1*4],21,085845DD1h
	HH	ecx,edx,ebp,ebx,dword ptr[edi+10*4],15,0FFEFF47Dh
	HH	edx,ebp,ebx,ecx,dword ptr[edi+ 3*4],10,08F0CCC92h
	HH	ebp,ebx,ecx,edx,dword ptr[edi+12*4], 6,0655B59C3h
	HH	ebx,ecx,edx,ebp,dword ptr[edi+ 5*4],21,0FC93A039h
	HH	ecx,edx,ebp,ebx,dword ptr[edi+14*4],15,0AB9423A7h
	HH	edx,ebp,ebx,ecx,dword ptr[edi+ 7*4],10,0432AFF97h
	HH	ebp,ebx,ecx,edx,dword ptr[edi+ 0*4], 6,0F4292244h

;       /* Round 3. */

	HH	ebx,ecx,edx,ebp,dword ptr[edi+ 2*4],23,0C4AC5665h
	HH	ecx,edx,ebp,ebx,dword ptr[edi+15*4],16,01FA27CF8h
	HH	edx,ebp,ebx,ecx,dword ptr[edi+12*4],11,0E6DB99E5h
	HH	ebp,ebx,ecx,edx,dword ptr[edi+ 9*4], 4,0D9D4D039h
	HH	ebx,ecx,edx,ebp,dword ptr[edi+ 6*4],23,004881D05h
	HH	ecx,edx,ebp,ebx,dword ptr[edi+ 3*4],16,0D4EF3085h
	HH	edx,ebp,ebx,ecx,dword ptr[edi+ 0*4],11,0EAA127FAh
	HH	ebp,ebx,ecx,edx,dword ptr[edi+13*4], 4,0289B7EC6h
	HH	ebx,ecx,edx,ebp,dword ptr[edi+10*4],23,0BEBFBC70h
	HH	ecx,edx,ebp,ebx,dword ptr[edi+ 7*4],16,0F6BB4B60h
	HH	edx,ebp,ebx,ecx,dword ptr[edi+ 4*4],11,04BDECFA9h
	HH	ebp,ebx,ecx,edx,dword ptr[edi+ 1*4], 4,0A4BEEA44h
	HH	ebx,ecx,edx,ebp,dword ptr[edi+14*4],23,0FDE5380Ch
	HH	ecx,edx,ebp,ebx,dword ptr[edi+11*4],16,06D9D6122h
	HH	edx,ebp,ebx,ecx,dword ptr[edi+ 8*4],11,08771F681h
	HH	ebp,ebx,ecx,edx,dword ptr[edi+ 5*4], 4,0FFFA3942h

;       /* Round 2. */

	HH	ebx,ecx,edx,ebp,dword ptr[edi+12*4],20,08D2A4C8Ah
	HH	ecx,edx,ebp,ebx,dword ptr[edi+ 7*4],14,0676F02D9h
	HH	edx,ebp,ebx,ecx,dword ptr[edi+ 2*4], 9,0FCEFA3F8h
	HH	ebp,ebx,ecx,edx,dword ptr[edi+13*4], 5,0A9E3E905h
	HH	ebx,ecx,edx,ebp,dword ptr[edi+ 8*4],20,0455A14EDh
	HH	ecx,edx,ebp,ebx,dword ptr[edi+ 3*4],14,0F4D50D87h
	HH	edx,ebp,ebx,ecx,dword ptr[edi+14*4], 9,0C33707D6h
	HH	ebp,ebx,ecx,edx,dword ptr[edi+ 9*4], 5,021E1CDE6h
	HH	ebx,ecx,edx,ebp,dword ptr[edi+ 4*4],20,0E7D3FBC8h
	HH	ecx,edx,ebp,ebx,dword ptr[edi+15*4],14,0D8A1E681h
	HH	edx,ebp,ebx,ecx,dword ptr[edi+10*4], 9,002441453h
	HH	ebp,ebx,ecx,edx,dword ptr[edi+ 5*4], 5,0D62F105Dh
	HH	ebx,ecx,edx,ebp,dword ptr[edi+ 0*4],20,0E9B6C7AAh
	HH	ecx,edx,ebp,ebx,dword ptr[edi+11*4],14,0265E5A51h
	HH	edx,ebp,ebx,ecx,dword ptr[edi+ 6*4], 9,0C040B340h
	HH	ebp,ebx,ecx,edx,dword ptr[edi+ 1*4], 5,0F61E2562h

;       /* Round 1. */

	HH	ebx,ecx,edx,ebp,dword ptr[edi+15*4],22,049B40821h
	HH	ecx,edx,ebp,ebx,dword ptr[edi+14*4],17,0A679438Eh
	HH	edx,ebp,ebx,ecx,dword ptr[edi+13*4],12,0FD987193h
	HH	ebp,ebx,ecx,edx,dword ptr[edi+12*4], 7,06B901122h
	HH	ebx,ecx,edx,ebp,dword ptr[edi+11*4],22,0895CD7BEh
	HH	ecx,edx,ebp,ebx,dword ptr[edi+10*4],17,0FFFF5BB1h
	HH	edx,ebp,ebx,ecx,dword ptr[edi+ 9*4],12,08B44F7AFh
	HH	ebp,ebx,ecx,edx,dword ptr[edi+ 8*4], 7,0698098D8h
	HH	ebx,ecx,edx,ebp,dword ptr[edi+ 7*4],22,0FD469501h
	HH	ecx,edx,ebp,ebx,dword ptr[edi+ 6*4],17,0A8304613h
	HH	edx,ebp,ebx,ecx,dword ptr[edi+ 5*4],12,04787C62Ah
	HH	ebp,ebx,ecx,edx,dword ptr[edi+ 4*4], 7,0F57C0FAFh
	HH	ebx,ecx,edx,ebp,dword ptr[edi+ 3*4],22,0C1BDCEEEh
	HH	ecx,edx,ebp,ebx,dword ptr[edi+ 2*4],17,0242070DBh
	HH	edx,ebp,ebx,ecx,dword ptr[edi+ 1*4],12,0E8C7B756h
	HH	ebp,ebx,ecx,edx,dword ptr[edi+ 0*4], 7,0D76AA478h

;	pop	esi				; poiter to buffer

	mov	dword ptr[esi+0*4], ebp
	mov	dword ptr[esi+1*4], ebx
	mov	dword ptr[esi+2*4], ecx
	mov	dword ptr[esi+3*4], edx

	add	edi, 64			; next block

	dec	dword ptr[rounds_inv]
	jnz	_next

_padd:

	mov	eax, fpadd_inv
	test	eax, eax
	jz	_end
	xor	fpadd_inv, eax
	mov	rounds_inv, eax
	mov	edi, offset paddbuf_inv
	jmp	_next
_end:

	popad
	ret	0Ch

MD5_INV endp

OPTION PROLOGUE: PROLOGUEDEF
OPTION EPILOGUE: EPILOGUEDEF